<template>
  <div class="page">
    <div
      v-if="routeFrom && (routeFrom.name === 'Accounts' || routeFrom.name === null)"
      class="back-link"
      @click="$router.push(routeFrom)"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Gestion des comptes
      </span>
    </div>
    <div
      v-else
      class="back-link"
      @click="$router.push({ name: 'Spheres' })"
    >
      <b-icon-chevron-left font-scale="1.3" />
      <span>
        Liste des groupes d'organisations
      </span>
    </div>
    <div
      class="add-sphere-form"
    >
      <b-overlay
        id="overlay-background"
        :show="loading"
        :variant="'white'"
        :opacity="0.7"
        :blur="'2px'"
        rounded="sm"
        no-wrap
      >
      </b-overlay>
      <h2>Ajouter un groupe d'organisations</h2>
      <ValidationObserver v-slot="{ handleSubmit }">
        <form>
          <div class="form-row">
            <div class="form-group col-12">
              <ValidationProvider rules="required" v-slot="{ classes, errors }">
                <div class="control" :class="classes">
                  <label class="required">Nom du groupe d'organisations</label>
                  <p>Inscrire le nom complet et en toutes lettres du groupe d'organisations. Ex: Communauté des Communes Rurales de l'Entre-Deux-Mers</p>
                  <input
                    v-model="name"
                    class="form-control"
                    type="text"
                    placeholder="Nom du groupe d'organisations"
                  >
                  <span class="form-errors">{{ errors[0] }}</span>
                </div>
              </ValidationProvider>
            </div>
          </div>
          <div class="form-row">
            <div class="form-group col-12">
              <label>Description du groupe d'organisations</label>
              <textarea
                v-model="description"
                class="form-control"
              />
            </div>
          </div>
          <div class="form-footer">
            <div>
              <b-button
                variant="outline-secondary"
                @click="$router.go(-1)"
              >
                Annuler
              </b-button>
            </div>
            <div class="btn-group-vertical">
              <b-button
                style="margin-bottom: 0.8em;"
                variant="primary"
                @click="handleSubmit(addSphere)"
              >
                Enregistrer
              </b-button>
              <b-button
                variant="primary"
                @click="handleSubmit(addSphereAndContinue)"
              >
                Enregistrer et continuer
              </b-button>
            </div>
          </div>
        </form>
      </ValidationObserver>
    </div>
  </div>
</template>

<script>
import { mapState, mapMutations, mapActions } from 'vuex';

import { ValidationObserver, ValidationProvider, extend, configure } from 'vee-validate';
import { required } from 'vee-validate/dist/rules';

import { slugify } from '@/utils';


extend('required', {
  ...required,
  message: 'Ce champ est requis'
});

configure({
  classes: {
    valid: 'is-valid',
    invalid: 'is-invalid'
  }
});

export default {
  name: 'AddSphere',

  components: {
    ValidationObserver,
    ValidationProvider
  },

  data() {
    return {
      loading: false,
      routeFrom: null,
      // form
      name: null,
      description: null
    }
  },

  computed: {
    ...mapState('usergroups', [
      'lastCreatedUsergroup'
    ])
  },

  beforeRouteEnter(to, from, next) {
    next((vm) => {
        vm.routeFrom = from;
    });
  },

  methods: {
    ...mapMutations('usergroups', [
      'SET_LAST_CREATED_USERGROUP'
    ]),
    ...mapActions('usergroups', [
      'GET_USERGROUP_DETAIL',
      'GET_USERGROUPS_SPHERES_LIST',
      'CREATE_USERGROUP'
    ]),

    addSphere() {
      this.loading = true;
      const data = {
        display_name: this.name,
        codename: slugify(this.name),
        description: this.description,
        usergroup_type: {
          codename: 'group-of-organisation'
        },
        is_active: true
      };
      this.CREATE_USERGROUP(data)
      .then(() => {
        this.GET_USERGROUPS_SPHERES_LIST({
          direction: null,
          field: null
        }).then(() => {
          this.loading = false;
          this.$router.push({ name: 'Spheres' });
        });
      }).catch(() => {
        this.loading = false;
      });
    },
    addSphereAndContinue() {
      this.loading = true;
      const data = {
        display_name: this.name,
        codename: slugify(this.name),
        description: this.description,
        usergroup_type: {
          codename: 'group-of-organisation'
        },
        is_active: true
      };
      this.CREATE_USERGROUP(data)
      .then(() => {
        if (this.lastCreatedUsergroup) {
          Promise.all([
            this.GET_USERGROUP_DETAIL(this.lastCreatedUsergroup.id),
            this.GET_USERGROUPS_SPHERES_LIST({
              direction: null,
              field: null
            })
          ]).then(() => {
            this.loading = false;
            this.$router.push({ name: 'SphereDetail', params: { id: this.lastCreatedUsergroup.id } });
            this.SET_LAST_CREATED_USERGROUP(null);
          });
        } else {
          this.loading = false;
        }
      }).catch(() => {
        this.loading = false;
      });
    }
  }
}
</script>

<style lang="less" scoped>
.add-sphere-form {
  margin-left: max(2em, auto);
  margin-right: max(2em, auto);
}

form {
  min-width: 800px;
  max-width: 1000px;
}

h2 {
  color: @blue;
  margin-top: 0.5em;
  margin-left: 0.5em;
}

h4 {
  color: @blue;
  margin-top: 0.8em;
}

button {
  margin: 1em 2em 0 0;
  font-size: 1.3em;
}
</style>
